/*
 * Nombre del Proyecto:
     Controlador de acceso.c
 * Nombre del Autor:
    Roberto Noboa
 * Descripcin:
     1. Es el convertidor ADC que que consiste en la lectura de los valores analgicos de un potencimetro 
     colocado en patita RE0/AN5 del PIC16F887,
    presentando las variaciones de valores en binario y su equivalente decimal en una pantalla LCD 4x20.

     2. Se tiene que ingresar 3 dgitos y esto se comparar con
     un arreglo que contiene la clave y de ser correcto lo que se
     ingres por aparece ne le display la G que indica que gan si despues de 5 intentos
     no acierta aparece en el display la P que indic perdio...
     
 * Test configuration:
     MCU:             PIC16F887
     Oscillator:      HS, 08.0000 MHz
     SW:              mikroC PRO for PIC

 * NOTES:

*/
unsigned short mask(unsigned short num);
unsigned short kyp(unsigned short kp);
unsigned short clave(char txt[],char txt2[],short size);
unsigned long a,tmp;
unsigned int q;
unsigned short u,kp,m,n,o,az,cnt=1,n2,p1=0,p2;
char cente[5],cst2[6]="357",txt2[6];


// Keypad module connections
char  keypadPort at PORTD;
// End Keypad module connections

// LCD module connections
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;
// End LCD module connections


void main() {
  ANSEL  = 0x20;              // Configure AN2 pin as analog
  ANSELH = 0;                 // Configure other AN pins as digital I/O
  C1ON_bit = 0;               // Disable comparators
  C2ON_bit = 0;

  TRISA  = 0;              // PORTA is input
  TRISC  = 0;                 // PORTC is output

  Keypad_Init();                           // Initialize Keypad
  Lcd_Init();                              // Initialize Lcd
men:
  Lcd_Cmd(_LCD_CLEAR);                      // Clear display
  Lcd_Cmd(_LCD_CURSOR_OFF);                 // Cursor off
  do{
      PORTA=0X77;
      PORTC=0X37;
      Lcd_Out(1, 1, "1. PARTE A");
      Lcd_Out(3, 1, "2. PARTE B");
      kp = 0;
      do
        kp = Keypad_Key_Click();             // Store key code in kp variable
      while (!kp);
      az=kyp(kp);

        if(az==49){
        Lcd_Cmd(_LCD_CLEAR);
        ADC_Init();
        while(1){
        PORTA=0;
        PORTC=0;
        Lcd_Out(1, 4, "CONVERSION ADC");
        tmp=ADC_Read(5);
        a=(tmp*489);
        m=a/100000;
        n=(a%100000)/10000;
        q=(a%100000)%10000;
        o=q/1000;
        u=(q%1000)/100;
        
        p2=tmp;
        p2&=0x01;
        ShortToStr(p2,cente);
        Lcd_Chr(2, 15, cente[3]);
        p2=tmp>>1;
        p2&=0x01;
        ShortToStr(p2,cente);
        Lcd_Chr(2, 14, cente[3]);
        p2=tmp>>2;
        p2&=0x01;
        ShortToStr(p2,cente);
        Lcd_Chr(2, 13, cente[3]);
        p2=tmp>>3;
        p2&=0x01;
        ShortToStr(p2,cente);
        Lcd_Chr(2, 12, cente[3]);
        p2=tmp>>4;
        p2&=0x01;
        ShortToStr(p2,cente);
        Lcd_Chr(2, 11, cente[3]);
        p2=tmp>>5;
        p2&=0x01;
        ShortToStr(p2,cente);
        Lcd_Chr(2, 10, cente[3]);
        p2=tmp>>6;
        p2&=0x01;
        ShortToStr(p2,cente);
        Lcd_Chr(2, 9, cente[3]);
        p2=tmp>>7;
        p2&=0x01;
        ShortToStr(p2,cente);
        Lcd_Chr(2, 8, cente[3]);
        p2=tmp>>8;
        p2&=0x01;
        ShortToStr(p2,cente);
        Lcd_Chr(2, 7, cente[3]);
        p2=tmp>>9;
        p2&=0x01;
        ShortToStr(p2,cente);
        Lcd_Chr(2, 6, cente[3]);
        ShortToStr(m,cente);
        Lcd_Chr(3, 9, cente[3]);
        Lcd_Chr(3, 10,'.');
        ShortToStr(n,cente);
        Lcd_Chr(3, 11, cente[3]);
        ShortToStr(o,cente);
        Lcd_Chr(3, 12, cente[3]);
        ShortToStr(u,cente);
        Lcd_Chr(3, 13, cente[3]);
          kp = Keypad_Key_Press();             // Store key code in kp variable

        az=kyp(kp);
        if (az==42)
        goto men;
        }
      }
      
      if(az==50){
      Lcd_Cmd(_LCD_CLEAR);                      // Clear display
      do{
         PORTA=0;
         PORTC=mask(p1%10);
         Lcd_Out(1, 1, "Ingrese clave:");
         kp = 0;
         do
           kp = Keypad_Key_Click();             // Store key code in kp variable
         while (!kp);

         az=kyp(kp);
         if (az==42)
         goto men;

        Lcd_Out(2, cnt, "*"); //imprime en pantalla la contrasea
        txt2[cnt-1]=az;
        cnt=cnt++;
        if(cnt==4){
         n2=clave(txt2,cst2,6);
         if(n2==1)
         {
          if (p1<5){
          PORTA=0x7D;
          p1=0;
          }
          Lcd_Cmd(_LCD_CLEAR);
          Lcd_Out(2,1,"CLAVE CORRECTA");
          Lcd_Out(4,1,"ACCESO");
          Delay_ms(2000);
         }
         else{
          p1++;
          PORTC=mask(p1%10);
          if (p1==5){
          PORTA=0x73;
          p1=0;
          }
          Lcd_Cmd(_LCD_CLEAR);
          Lcd_Out(1,1,"CLAVE INCORRECTA");
          Lcd_Out(3,1,"ACCESO DENEGADO");
          Delay_ms(2000);
         }
        Lcd_Cmd(_LCD_CLEAR);
        cnt=1;
        }
        } while (1);

      }
 } while (1);
}

unsigned short clave(char txt[],char txt2[],short size){
 unsigned short i,x=0;
 for(i=0;i<size;i++)
 {
   if(txt[i]==txt2[i]){
    x++;
   }
 }
 if(x==size){
  return 1;
 }
 else return 0;
}

unsigned short mask(unsigned short num) {
switch (num) {
case 0 : return 0x3F;
case 1 : return 0x06;
case 2 : return 0x5B;
case 3 : return 0x4F;
case 4 : return 0x66;
case 5 : return 0x6D;
case 6 : return 0x7D;
case 7 : return 0x07;
case 8 : return 0x7F;
case 9 : return 0x6F;
}
}

unsigned short kyp(unsigned short kp) {
switch (kp) {
        case  1: return 55; // 7        // Uncomment this block for keypad4x4
        case  2: return 52;  // 4
        case  3: return 49;  // 1
        case  4: return 42;  // *
        case  5: return 56;  // 8
        case  6: return 53;  // 5
        case  7: return 50;  // 2
        case  8: return 48;  // 0
        case  9: return 57;  // 9
        case 10: return 54;  // 6
        case 11: return 51;  // 3
        case 12: return 35;  // #
        case 13: return 65;  // A
        case 14: return 66;  // B
        case 15: return 67;  // C
        case 16: return 68;  // D
      }
}